VERSION 5.00
Begin VB.Form frmCOMtest 
   Caption         =   "Form1"
   ClientHeight    =   4230
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7050
   LinkTopic       =   "Form1"
   ScaleHeight     =   282
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   470
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmCOMtest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const lngBorderWidth As Long = 128
Private Const lngMoveRate As Long = 16

Private ResMan As New ResourceManager
Private map As MapFile
Private lngX As Long, lngY As Long
    
Private Sub Form_Load()
    ResMan.RootPath = "C:\Hacked\Outpost2\"

    Dim inStream As StreamReader
    Dim volFile As ArchiveReader
    Set volFile = ResMan.LoadVolFile("maps.vol", 1)
    ResMan.AddArchiveToSearch volFile
    Set volFile = ResMan.LoadVolFile("sheets.vol", 1)
    ResMan.AddArchiveToSearch volFile
    Set volFile = ResMan.LoadVolFile("sound.vol", 1)
    ResMan.AddArchiveToSearch volFile
    Set volFile = ResMan.LoadVolFile("story.vol", 1)
    ResMan.AddArchiveToSearch volFile
    Set volFile = ResMan.LoadVolFile("voices.vol", 1)
    ResMan.AddArchiveToSearch volFile
    Set volFile = Nothing

    Set map = ResMan.LoadMapFile("cm03.map", TileGroups)

    ' Test tile group pasting (uncomment line to see)
    Dim tileGrp As TileGroup
    Set tileGrp = map.TileGroup(197)
    'map.Paste 0, 5, tileGrp
    Set tileGrp = Nothing

    ' Test setting a tile (uncomment line to see)
    'map.mappingIndex(0, 0) = &H47B
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Not map Is Nothing And (Button And vbLeftButton) = vbLeftButton Then
        ' Cheap hack scroll code :) **TODO** Remove or improve
        If (x < lngBorderWidth) Then lngX = lngX - lngMoveRate
        If (x > ScaleWidth - lngBorderWidth) Then lngX = lngX + lngMoveRate
        If (y < lngBorderWidth) Then lngY = lngY - lngMoveRate
        If (y > ScaleHeight - lngBorderWidth) Then lngY = lngY + lngMoveRate

        If lngX > map.TileWidth * 32 - ScaleWidth Then lngX = map.TileWidth * 32 - ScaleWidth
        If lngY > map.TileHeight * 32 - ScaleHeight Then lngY = map.TileHeight * 32 - ScaleHeight
        If lngX < 0 Then lngX = 0
        If lngY < 0 Then lngY = 0

        Form_Paint
    End If
End Sub

Private Sub Form_Paint()
    If Not map Is Nothing Then
        Caption = Format$(map.TileWidth) + "x" + Format$(map.TileHeight)
        map.Draw Me.hDC, lngX, lngY, ScaleWidth, ScaleHeight
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set map = Nothing
End Sub
